%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Logist file for DynamicReverseEngine
% Rule used syntax ProLog (with tuProlog enhancement)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Last update for v."Joss" 
% Author: Eugen Kuptsov
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% !!! Please,to not correct code.. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%-------- rules for search paths between objects --------------- 

% call goal example
% ?- path0(1,5,[edge(1,2),edge(1,3),edge(1,4),edge(2,5),edge(3,5)]).

tmp_pl('$DRE.PL').

path0(Obj1,Obj2,L):- 
  tmp_pl(FileOut), 
  tell(FileOut),        
  abolish(edge/2),
  abolish(t/2),
  abolish(p/1),
  set_edge(L),
  path1(Obj1,Obj2),
  fail.
path0(_,_,_):-
  write(hlt(0)),
  put('.'),
  told.

set_edge([edge(X,Y)|L]):-
  assertz( edge(X,Y) ),     
  assertz( edge(Y,X) ), 
  set_edge(L).
set_edge([]).

path1(X,Z):- 
  path2(X,Z,[Z],L),
  length(L,N),
  write(t(L,N)),
  put('.'),
  nl.
 
path2(X,X,L,L).
path2(X,Z,N,LL):- 
  once(edge(Y,Z)),
  not(member(Y,N)),
  retract(edge(Y,Z)),  
  retract(edge(Z,Y)),  
  path2(X,Y,[Y|N],LL).

member(Y,[Y|N]).
member(Y,[X|N]):- 
  member(Y,N).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ul:-
  abolish(t/2),
  abolish(p/1),
  findall(L,t(L,_),LL),  
  lc(LL,[],LLL),         
  mc(LLL,[],ML),         
  !,
  sl(ML).                
ul.

lc([],LL,LL).
lc([T|L],L0,LL):- 
  append(L0,T,L1), 
  lc(L,L1,LL).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ulmin:-
  abolish(t/2),
  abolish(p/1),
  asserta(min(0)),
  findall([N,L],t(L,N),LL),
  fmin(LL),
  call(min(Min)),
  lcmin(Min,LL,[],LLL),
  mc(LLL,[],ML),
  !,
  sl(ML).
ulmin.

fmin([]).
fmin([[N,_]|L]):- 
  call(min(Min)),
  fmin1(N,Min),
  fmin(L).

fmin1(N,0):-
  asserta(min(N)),
  !.
fmin1(N,Min):-
  N < Min,
  abolish( min/1 ),
  asserta(min(N)),
  !.
fmin1(_,_).

lcmin(_,[],LL,LL).
lcmin(Min,[[N,T]|L],L0,LL):- 
  ( Min == N,
    append(L0,T,L1)
    ;
    L1=L0 
  ), 
  lcmin(Min,L,L1,LL).

%%%%%%%%%%%%%%%%%

sl([]).
sl([X|L]):-
  !,
  asserta( p(X) ),     
  sl(L).

mc([],LL,LL).
mc([X|L],N,LL):-
  ( 
    not(member(X,N)),
    L1 = [X|N] 
    ;
    L1 = N 
  ),
  mc(L,L1,LL).
